fgl-5.5.2.3: Martin Erwig's Functional Graph Library

Safe Haskell | None
Language | Haskell98

Data.Graph.Inductive.Monad.IOArray

Contents

- Graph Representation
- Utilities

Description

Static IOArray-based Graphs

Synopsis

- newtype SGr a b = SGr (GraphRep a b)
- type GraphRep a b = (Int, Array Node (Context' a b), IOArray Node Bool)
- type Context' a b = Maybe (Adj b, a, Adj b)
- type USGr = SGr () ()
- defaultGraphSize :: Int
- emptyN :: Int -> IO (SGr a b)
- removeDel :: IOArray Node Bool -> Adj b -> IO (Adj b)

# Graph Representation

newtype SGr a b Source

Constructors

SGr (GraphRep a b) |

Instances

GraphM IO SGr Source |
(Show a, Show b) => Show (IO (SGr a b)) Source |
(Show a, Show b) => Show (SGr a b) Source |

type GraphRep a b = (Int, Array Node (Context' a b), IOArray Node Bool) Source

type Context' a b = Maybe (Adj b, a, Adj b) Source

type USGr = SGr () () Source

defaultGraphSize :: Int Source

emptyN :: Int -> IO (SGr a b) Source

# Utilities

removeDel :: IOArray Node Bool -> Adj b -> IO (Adj b) Source

filter list (of successors/predecessors) through a boolean ST array representing deleted marks